---
HTTP 的前世今生
---

#### 目录

1. HTTP/0.9
2. HTTP/1.0
3. HTTP/1.1
4. HTTP/2
5. HTTP/3
6. 总结

#### HTTP/0.9

在 1989 年，蒂姆·博纳斯 - 李发表了一篇论文，提出了在互联网上构建超链接文档系统的构想，这篇文章论文中确立了三项关键技术：

1. URI：即统一资源标识符，作为互联网上资源的唯一身份
2. HTML：即超文本标记语言，描述超文本文档
3. HTTP：即超文本传输协议，用来传输超文本

这一时期的 HTTP 被定义为 0.9 版，结构比较简单，为了便于服务器和客户端处理，它也采用了纯文本。李最初设想的系统里的文档都是只读的，所以只允许用 "GET" 动作从服务器上获取 HTML 文档，并且在响应请求之后立即关闭连接，功能非常有限。

#### HTTP/1.0

1996 年正式发布了 HTTP/1.0 版本，形式上已经和现在的 HTTP 差别不大了，例如：

1. 增加了 HEAD、POST 等新方法
2. 增加了响应状态码，标记可能的出错原因
3. 引入了协议版本号概念
4. 引入了 HTTP Header（头部）的概念，让 HTTP 处理请求和响应更加灵活
5. 传输的数据不再仅限于文本

但是 HTTP/1.0 并不是一个标准，而只是一份参考文档，不具有实际约束力。

#### HTTP/1.1

1999 年，HTTP/1.1 发布了 RFC 文档，它成为了一个正式的标准，这意味着今后互联网上的所有浏览器、服务器等，只要用到了 HTTP 协议，都要严格遵循这个标准。HTTP/1.1 主要的变更点有：

1. 增加了 PUT、DELETE 等新的方法
2. 增加了缓存管理和控制
3. 明确了连接管理，允许持久连接
4. 允许响应数据分块（chunked），利于传输大文件
5. 强制要求 Host 头，让互联网主机托管成为可能

##### HTTP/2

2015 年，发布了 HTTP/2，HTTP/2 的制定充分考虑了现今互联网的现状：宽带、移动、不安全，在高度兼容 HTTP/1.1 的同时在性能改善方面做了很大努力，主要的特点有：

1. 二进制协议，不再是纯文本
2. 可发起多个请求，废弃了 1.1 里的管道
3. 使用专用算法压缩头部，减少数据传输量
4. 允许服务器主动向客户端推送数据
5. 增加了安全性，要求加密通信

虽然 HTTP/2 到今天已经四岁，也衍生了 gRPC 等新协议，但由于 HTTP/1.1 实在是太过于经典和强势，目前它的普及率还比较低，大多数网站使用的仍然是 20 年前的 HTTP/1.1。

#### HTTP/3

在 HTTP/2 还处于草案时，Google 又发明了一个新的协议，叫做 QUIC，而且还是相同的套路，继续在 Chrome 和自家服务器试玩，依托它庞大的用户量和数据量，持续推动着 QUIC 协议成为互联网上的既成事实。

在 2018 年，互联网标准化组织 IETF 正式将 QUIC 纳入 HTTP/3 的标准化制定阶段。也许两三年后就会正式发布，到时候我们可能会跳过 HTTP/2 直接进入 HTTP/3。

#### 总结

1. HTTP 协议始于蒂姆的一篇论文
2. HTTP/0.9 是个简单的文本协议，只能获取文本资源
3. HTTP/1.0 确立了大部分现在使用的技术，但它不是正式标准
4. HTTP/1.1 是目前互联网上使用最广泛的协议，功能也非常完善
5. HTTP/2 基于 Google 的 SPDY 协议，注重性能改善，但还未普及
6. HTTP/3 基于 Google 的 QUIC 协议，是将来发展的方向